#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
long long a[1000001];
int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    long long n, i, m, s, ma = INT_MAX, mi;
    cin >> n;
    for (i = 1; i <= n; i++)
    {
        cin >> a[i];
        if (a[i] < ma)
        {
            ma = a[i];
            mi = i;
        }
    }
    for (i = 0; i < n-1; i++)
    {
        cin >> m >> s;
    }
    cout << ma << endl << 1 << endl << a[mi] << endl << 0;
    return 0;
}